Bug 1161119 - sonic-visualiser: tests fail on s390(x) ppc64(le)
Summary: sonic-visualiser: tests fail on s390(x) ppc64(le)
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: sonic-visualiser
Version: 21
Hardware: All
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Michel Alexandre Salim
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: ZedoraTracker PPCTracker F-ExcludeArch-ppc64le, PPC64LETracker
TreeView+ depends on / blocked
 
Reported: 2014-11-06 12:31 UTC by Jakub Čajka
Modified: 2014-12-06 10:02 UTC (History)
2 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2014-12-01 19:03:34 UTC


Attachments (Terms of Use)
Tests fix (1.20 KB, patch)
2014-11-06 12:31 UTC, Jakub Čajka
no flags Details | Diff

Description Jakub Čajka 2014-11-06 12:31:31 UTC
Created attachment 954427 [details]
Tests fix

Failing tests:
"QCOMPARE(rm.getValueForPositionUnclamped(0), 0.0);
QCOMPARE(rm.getValueForPositionUnclamped(9), 0.0);"

in TestRangeMapper.h with:

"
.
.
.
FAIL!  : TestRangeMapper::linearUpBackward() Compared doubles are not the same (fuzzy compare)
   Actual   (rm.getValueForPositionUnclamped(0)): -2.23517e-08
   Expected (0.0)                               : 0
   Loc: [o/../TestRangeMapper.h(80)]
FAIL!  : TestRangeMapper::linearDownBackward() Compared doubles are not the same (fuzzy compare)
   Actual   (rm.getValueForPositionUnclamped(9)): -2.23517e-08
   Expected (0.0)                               : 0
   Loc: [o/../TestRangeMapper.h(96)]
.
.
.
"
Tests fail due QCOMPARE is using qFuzzyCompare to compare floats internally, which may fail when one of a compared value is 0.0(documented behaviour, but bit perplexing as it's not affecting x86 in this case, probably rounding error...).

QT docs/bug:
http://qt-project.org/doc/qt-5/qtglobal.html#qFuzzyCompare-10
http://qt-project.org/doc/qt-5/qtest.html#QCOMPARE
https://bugreports.qt-project.org/browse/QTBUG-16819

Proposed workaround from documentation is not working, as it results in 1!=1. But using qFuzzyIsNull(undocumented, but used/recommended(see up mentioned bug)) in combination with QVERIFY result in tests pass on all Fedora kojis.

Scratch builds with patch:
http://koji.fedoraproject.org/koji/taskinfo?taskID=8053247
http://s390.koji.fedoraproject.org/koji/taskinfo?taskID=1601344
http://ppc.koji.fedoraproject.org/koji/taskinfo?taskID=2172191
http://arm.koji.fedoraproject.org/koji/taskinfo?taskID=2774957

In attachment is patch doing these changes.

Comment 1 Jakub Čajka 2014-11-06 12:44:23 UTC
Patch sent to upstream ML sv1-devel@lists.sourceforge.net.

Comment 2 Fedora Update System 2014-11-07 11:26:40 UTC
sonic-visualiser-2.4.1-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/FEDORA-2014-14258/sonic-visualiser-2.4.1-2.fc20

Comment 3 Fedora Update System 2014-11-07 11:28:20 UTC
sonic-visualiser-2.4.1-2.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/FEDORA-2014-14206/sonic-visualiser-2.4.1-2.fc21

Comment 4 Fedora Update System 2014-11-07 11:30:39 UTC
sonic-visualiser-2.4.1-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/FEDORA-2014-14254/sonic-visualiser-2.4.1-2.fc19

Comment 5 Fedora Update System 2014-11-09 15:45:31 UTC
Package sonic-visualiser-2.4.1-2.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing sonic-visualiser-2.4.1-2.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-14254/sonic-visualiser-2.4.1-2.fc19
then log in and leave karma (feedback).

Comment 6 Fedora Update System 2014-12-01 19:03:34 UTC
sonic-visualiser-2.4.1-2.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 7 Fedora Update System 2014-12-01 19:05:07 UTC
sonic-visualiser-2.4.1-2.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 8 Fedora Update System 2014-12-06 10:02:02 UTC
sonic-visualiser-2.4.1-2.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.